﻿Imports System.Windows.Forms

Public Class Optionen

    Private Sub Optionen_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ToolTip_Wiederholrate.SetToolTip(Me.TextBox_Wiederholrate, "Eingabe 1 bis 999" + vbCrLf + "Empfehlung:" + vbCrLf + "langsamer PC: > 150" + vbCrLf + "sonst: 20")
        ToolTip_FFT_Samples.SetToolTip(Me.ComboBox_FFT_Samples, "CPU-Last auch abhängig" + vbCrLf + "von FFT-Samples, Div" + vbCrLf + "Empfehlung:" + vbCrLf + "langsamer PC: <= 2048")
        ToolTip_Uss.SetToolTip(Me.TextBox_Uss, "Eingabe 0,5 bis 100 und 0" + vbCrLf + "0 keine Darstellung Uss")
        ToolTip_UssGraphik.SetToolTip(Me.TextBox_UssGraphik, "Eingabe 0,5 bis 2" + vbCrLf + "Amplitudenkorrektur")
        visible_ToolTip_Optionen(Form1.ToolTip)
    End Sub

    Private Sub TextBox_Wiederholrate_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox_Wiederholrate.KeyPress
        If Not IsNumeric(e.KeyChar) Then e.KeyChar = Nothing
    End Sub


    Private Sub TextBox_Wiederholrate_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox_Wiederholrate.Validating
        Select Case CInt(TextBox_Wiederholrate.Text)
            Case Is <= 0
                TextBox_Wiederholrate.Text = 1
            Case Is > 999
                TextBox_Wiederholrate.Text = 999
        End Select
    End Sub

    Private Sub TextBox_Uss_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox_Uss.KeyPress
        If Not IsNumeric(e.KeyChar) And e.KeyChar <> "," Then e.KeyChar = Nothing
    End Sub

    Private Sub TextBox_Uss_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox_Uss.Validating
        Dim zahl As Decimal
        If [Decimal].TryParse(TextBox_Uss.Text, zahl) Then
            If zahl < 0.5 And zahl <> 0 Then
                TextBox_Uss.Text = "0,5"
            ElseIf zahl > 100 Then
                TextBox_Uss.Text = "100"
            End If
        Else
            TextBox_Uss.Text = Form1.Uss_corr
        End If
    End Sub

    Private Sub TextBox_UssGraphik_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox_UssGraphik.KeyPress
        If Not IsNumeric(e.KeyChar) And e.KeyChar <> "," Then e.KeyChar = Nothing
    End Sub

    Private Sub TextBox_UssGraphik_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox_UssGraphik.Validating
        Dim zahl As Decimal
        If [Decimal].TryParse(TextBox_UssGraphik.Text, zahl) Then
            If zahl < 0.5 Then
                TextBox_UssGraphik.Text = "0,5"
            ElseIf zahl > 2 Then
                TextBox_UssGraphik.Text = "2"
            End If
        Else
            TextBox_UssGraphik.Text = Form1.UssGr_corr
        End If
    End Sub

    Private Sub CheckBox_Hinweise_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_Hinweise.Click
        visible_ToolTip_Optionen(CheckBox_Hinweise.Checked)
    End Sub

    Public Sub visible_ToolTip_Optionen(ByVal tmpToolTip As Boolean)
        ToolTip_Wiederholrate.Active = tmpToolTip
        ToolTip_FFT_Samples.Active = tmpToolTip
        ToolTip_Uss.Active = tmpToolTip
        ToolTip_UssGraphik.Active = tmpToolTip
        'Form1.visible_ToolTip(tmpToolTip)
        'Farben.visible_ToolTip(tmpToolTip)
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim tmpSamples As Int16
        Dim tmp_fft_exp_sampels As Byte

        Form1.Timer1.Stop()
        Form1.Timer1.Interval = TextBox_Wiederholrate.Text
        Form1.Timer1.Start()
        tmpSamples = ComboBox_FFT_Samples.Text
        tmp_fft_exp_sampels = Form1.fft_exp_sampels
        Form1.fft_exp_sampels = 0
        While tmpSamples > 512
            tmpSamples = tmpSamples >> 1
            Form1.fft_exp_sampels += 1
        End While
        If tmp_fft_exp_sampels <> Form1.fft_exp_sampels Then
            Form1.TimeLineData(Form1.TL_3) = 1
            Form1.fft_init()
            Form1.fft_init_values()
            Form1.fft_on = Not (Form1.fft_on)   ' aktuellen Zustand beibehalten, set_fft repetierend
            Form1.set_fft()
        End If
        Form1.UssGr_corr = TextBox_UssGraphik.Text
        Form1.ToolTip = CheckBox_Hinweise.Checked

        WriteRegEntry("Options", "Timer-Interval", TextBox_Wiederholrate.Text)
        WriteRegEntry("Options", "FFT-exp", Form1.fft_exp_sampels)
        WriteRegEntry("Options", "Uss-corr", TextBox_Uss.Text)
        WriteRegEntry("Options", "UssGraph-corr", Form1.UssGr_corr)
        WriteRegEntry("Options", "ToolTip", Form1.ToolTip)
        If TextBox_Uss.Text = 0 Then
            Form1.Uss_corr = 1
            Form1.Uss_Visible = False
        Else
            Form1.Uss_corr = TextBox_Uss.Text
            Form1.Uss_Visible = True
        End If
        Form1.visible_ToolTip(Form1.ToolTip)
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

End Class
