﻿Module scope
    Const SoftwareKey = "Software\myScope"

    Public Class ConstIntegerArray
        Protected Intgr() As Integer
        Public Sub New(ByVal Intgr() As Integer)
            Me.Intgr = DirectCast(Intgr.Clone(), Integer())
        End Sub
        Default Public ReadOnly Property Item(ByVal index As Integer) As Integer
            Get
                Return Intgr(index)
            End Get
        End Property
    End Class

    Public Function ReadRegEntry(ByVal SubKey As String, ByVal VarName As String, ByVal defaultValue As String) As String
        Dim Result As String

        Result = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\" + SoftwareKey + "\" + SubKey, VarName, Nothing)
        If Result = Nothing Then
            My.Computer.Registry.CurrentUser.CreateSubKey(SoftwareKey + "\" + SubKey)
            WriteRegEntry(SubKey, VarName, defaultValue)
            Result = defaultValue
        End If
        Return (Result)
    End Function

    Public Sub WriteRegEntry(ByVal SubKey As String, ByVal VarName As String, ByVal Value As String)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\" + SoftwareKey + "\" + SubKey, VarName, Value)
    End Sub

    Public Function ReadRegColor(ByVal SubKey As String, ByVal VarName As String, ByVal defaultValue As Color) As Color
        Dim Result As Color

        If My.Computer.Registry.GetValue("HKEY_CURRENT_USER\" + SoftwareKey + "\" + SubKey, VarName, Nothing) = Nothing Then
            My.Computer.Registry.CurrentUser.CreateSubKey(SoftwareKey + "\" + SubKey)
            WriteRegColor(SubKey, VarName, defaultValue)
            Result = defaultValue
        Else
            Result = Color.FromArgb(My.Computer.Registry.GetValue("HKEY_CURRENT_USER\" + SoftwareKey + "\" + SubKey, VarName, Nothing))
        End If
        Return (Result)
    End Function

    Public Sub WriteRegColor(ByVal SubKey As String, ByVal VarName As String, ByVal Value As Color)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\" + SoftwareKey + "\" + SubKey, VarName, Value.ToArgb)
    End Sub

End Module
